diff -pruN 0.34~cvs20160606-15/debian/changelog 0.34~cvs20160606-16/debian/changelog
--- 0.34~cvs20160606-15/debian/changelog	2024-07-06 15:28:41.000000000 +0000
+++ 0.34~cvs20160606-16/debian/changelog	2024-07-08 16:37:00.000000000 +0000
@@ -1,3 +1,10 @@
+dietlibc (0.34~cvs20160606-16) unstable; urgency=medium
+
+  [ Helge Deller ]
+  * fix socketfns test crash in recvfrom()
+
+ -- Thorsten Glaser <tg@mirbsd.de>  Mon, 08 Jul 2024 18:37:00 +0200
+
 dietlibc (0.34~cvs20160606-15) unstable; urgency=medium
 
   * upload to unstable reverting GCC 14 test B-D
diff -pruN 0.34~cvs20160606-15/debian/patches/bugfixes/dietlibc-hppa-socketfns-fix.patch 0.34~cvs20160606-16/debian/patches/bugfixes/dietlibc-hppa-socketfns-fix.patch
--- 0.34~cvs20160606-15/debian/patches/bugfixes/dietlibc-hppa-socketfns-fix.patch	1970-01-01 00:00:00.000000000 +0000
+++ 0.34~cvs20160606-16/debian/patches/bugfixes/dietlibc-hppa-socketfns-fix.patch	2024-07-08 16:35:40.000000000 +0000
@@ -0,0 +1,29 @@
+Description: fix socketfns testcase crash in recvfrom on hppa
+ The problem is with recvfrom(), which takes 6 arguments.
+ The 5th and 6th argument is pushed on the stack by gcc, and
+ on hppa the argument is moved from the stack into a register
+ in __unified_syscall5 and __unified_syscall6 in parisc/unified.S
+ before jumping into the kernel.
+ .
+ Now, in syscalls.s/__recvfrom.S we have:
+  syscall_weak(recvfrom,recvfrom,__libc_recvfrom)
+ which adds the weak function, but actually it should be (for hppa):
+  syscall6_weak(recvfrom,recvfrom,__libc_recvfrom)
+ .
+ So, instead of adding and ifdef for hppa/syscall6_weak, simply
+ drop the weak function and call the normal __unified_syscall6.
+ .
+ I think it was simply luck why the testcase succeeded on physical machines.
+Author: Helge Deller <deller@gmx.de>
+Bug-Debian: https://bugs.debian.org/1030998
+Forwarded: no
+
+--- a/syscalls.s/__recvfrom.S
++++ b/syscalls.s/__recvfrom.S
+@@ -1,5 +1,5 @@
+ #include "syscalls.h"
+ 
+-#ifdef __NR_recvfrom
++#if defined(__NR_recvfrom) && !defined(__hppa__)
+ syscall_weak(recvfrom,recvfrom,__libc_recvfrom)
+ #endif
diff -pruN 0.34~cvs20160606-15/debian/patches/series 0.34~cvs20160606-16/debian/patches/series
--- 0.34~cvs20160606-15/debian/patches/series	2024-07-06 14:28:19.000000000 +0000
+++ 0.34~cvs20160606-16/debian/patches/series	2024-07-08 16:33:49.000000000 +0000
@@ -33,6 +33,7 @@ bugfixes/cflags.diff
 bugfixes/x32-struct-member-sizes.diff
 bugfixes/hppa-socketcalls.diff
 bugfixes/hppa-update.diff
+bugfixes/dietlibc-hppa-socketfns-fix.patch
 bugfixes/gcc14.diff
 
 # New features not yet in upstream
diff -pruN 0.34~cvs20160606-15/debian/unittests/suite.sh 0.34~cvs20160606-16/debian/unittests/suite.sh
--- 0.34~cvs20160606-15/debian/unittests/suite.sh	2024-07-06 14:28:19.000000000 +0000
+++ 0.34~cvs20160606-16/debian/unittests/suite.sh	2024-07-08 16:37:00.000000000 +0000
@@ -86,16 +86,12 @@ EXPECT_FAIL=""
 NO_STACK_PROTECTOR=""
 HOST_ARCH=$(dpkg-architecture -qDEB_HOST_ARCH)
 if test 1 = $QEMU; then
-	# socketfns need updating qemu to match Linux recent changes
 	# fadvise is possibly broken on 32bit BE mips, and 32bit PowerPC Qemu
 	#   (syscall also fails with glibc, as of Qemu 2.5)
 	# printf tests are broken plain powerpc32 (but not powerpcspe), because
 	# we compile dietlibc with -mpowerpc-gpopt, but Qemu doesn't emulate the
 	# FPU instructions required for that to work (as of Qemu 2.5)
 	case $HOST_ARCH in
-	(hppa)
-		EXPECT_FAIL="debian/unittests/socketfns.c"
-		;;
 	(mips|powerpcspe)
 		EXPECT_FAIL="test/fadvise.c"
 		;;
